Index: /LMDZ6/trunk/libf/phylmd/lmdz_lscp.f90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/lmdz_lscp.f90	(revision 5407)
+++ /LMDZ6/trunk/libf/phylmd/lmdz_lscp.f90	(revision 5408)
@@ -108,12 +108,12 @@
 USE lmdz_lscp_tools, ONLY : fallice_velocity, distance_to_cloud_top
 USE lmdz_lscp_condensation, ONLY : condensation_lognormal, condensation_ice_supersat
-USE lmdz_lscp_poprecip, ONLY : poprecip_precld, poprecip_postcld
+USE lmdz_lscp_precip, ONLY : histprecip_precld, poprecip_precld, poprecip_postcld
 
 ! Use du module lmdz_lscp_ini contenant les constantes
 USE lmdz_lscp_ini, ONLY : prt_level, lunout, eps
-USE lmdz_lscp_ini, ONLY : seuil_neb, niter_lscp, iflag_evap_prec, t_coup, DDT0, ztfondue, rain_int_min
+USE lmdz_lscp_ini, ONLY : seuil_neb, niter_lscp, iflag_evap_prec, DDT0, rain_int_min
 USE lmdz_lscp_ini, ONLY : ok_radocond_snow, a_tr_sca, cld_expo_con, cld_expo_lsc
 USE lmdz_lscp_ini, ONLY : iflag_cloudth_vert, iflag_rain_incloud_vol, iflag_t_glace, t_glace_min 
-USE lmdz_lscp_ini, ONLY : coef_eva, coef_sub,cld_tau_lsc, cld_tau_con, cld_lc_lsc, cld_lc_con
+USE lmdz_lscp_ini, ONLY : cld_tau_lsc, cld_tau_con, cld_lc_lsc, cld_lc_con
 USE lmdz_lscp_ini, ONLY : iflag_bergeron, iflag_fisrtilp_qsat, iflag_vice, cice_velo, dice_velo
 USE lmdz_lscp_ini, ONLY : iflag_autoconversion, ffallv_con, ffallv_lsc, min_frac_th_cld
@@ -267,5 +267,4 @@
   ! LOCAL VARIABLES:
   !----------------
-  REAL,DIMENSION(klon) :: qsl, qsi                                ! saturation threshold at current vertical level
   REAL,DIMENSION(klon) :: qice_ini
   REAL :: zct, zcl,zexpo
@@ -284,8 +283,6 @@
   REAL, DIMENSION(klon) :: zfice_th
   REAL, DIMENSION(klon) :: qcloud, qincloud_mpc
-  REAL, DIMENSION(klon) :: zrfl, zrfln
-  REAL :: zqev, zqevt 
-  REAL, DIMENSION(klon) :: zifl, zifln, ziflprev
-  REAL :: zqev0,zqevi, zqevti
+  REAL, DIMENSION(klon) :: zrfl
+  REAL, DIMENSION(klon) :: zifl, ziflprev
   REAL, DIMENSION(klon) :: zoliq, zcond, zq, zqn
   REAL, DIMENSION(klon) :: zoliql, zoliqi
@@ -294,11 +291,10 @@
   REAL, DIMENSION(klon) :: zdz,iwc
   REAL :: zchau,zfroi
-  REAL, DIMENSION(klon) :: zfice,zneb,znebprecip
-  REAL :: zmelt,zrain,zsnow,zprecip
+  REAL, DIMENSION(klon) :: zfice,zneb
+  REAL :: zrain,zsnow,zprecip
   REAL, DIMENSION(klon) :: dzfice
   REAL, DIMENSION(klon) :: zfice_turb, dzfice_turb
   REAL :: zsolid
   REAL, DIMENSION(klon) :: qtot, qzero
-  REAL, DIMENSION(klon) :: dqsl,dqsi
   REAL :: smallestreal
   !  Variables for Bergeron process
@@ -310,6 +306,4 @@
   REAL :: zfrac_lessi
   REAL, DIMENSION(klon) :: zprec_cond
-  REAL :: zmair
-  REAL :: zcpair, zcpeau
   REAL, DIMENSION(klon) :: zlh_solid
   REAL, DIMENSION(klon) :: ztupnew
@@ -318,5 +312,5 @@
   REAL, DIMENSION(klon) :: zrflclr, zrflcld
   REAL, DIMENSION(klon) :: d_zrfl_clr_cld, d_zifl_clr_cld
-  REAL, DIMENSION(klon) :: d_zrfl_cld_clr, d_zifl_cld_clr 
+  REAL, DIMENSION(klon) :: d_zrfl_cld_clr, d_zifl_cld_clr
   REAL, DIMENSION(klon) :: ziflclr, ziflcld
   REAL, DIMENSION(klon) :: znebprecipclr, znebprecipcld
@@ -369,5 +363,4 @@
 ! Few initialisations
 
-znebprecip(:)=0.0
 ctot_vol(1:klon,1:klev)=0.0
 rneblsvol(1:klon,1:klev)=0.0
@@ -488,4 +481,6 @@
 DO k = klev, 1, -1
 
+    qice_ini = qi_seri(:,k)
+
     IF (k.LE.klev-1) THEN
        iftop=.false. 
@@ -511,257 +506,34 @@
         !c_iso init of iso
     ENDDO
+
+    ! --------------------------------------------------------------------
+    ! P1> Precipitation processes, before cloud formation:
+    !     Thermalization of precipitation falling from the overlying layer AND
+    !     Precipitation evaporation/sublimation/melting
+    !---------------------------------------------------------------------
    
     !================================================================
     ! Flag for the new and more microphysical treatment of precipitation from Atelier Nuage (R)
-    IF (ok_poprecip) THEN
-
-            CALL poprecip_precld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
-                              zt, ztupnew, zq, zmqc, znebprecipclr, znebprecipcld, &
-                              zqvapclr, zqupnew, &
-                              zrfl, zrflclr, zrflcld, &
-                              zifl, ziflclr, ziflcld, &
-                              dqreva(:,k),dqssub(:,k) &
-                             )
+    IF ( ok_poprecip .OR. ( iflag_evap_prec .EQ. 6 ) ) THEN
+
+      CALL poprecip_precld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
+                        zt, ztupnew, zq, zmqc, znebprecipclr, znebprecipcld, &
+                        zqvapclr, zqupnew, &
+                        zrfl, zrflclr, zrflcld, &
+                        zifl, ziflclr, ziflcld, &
+                        dqreva(:,k), dqssub(:,k) &
+                        )
 
     !================================================================
     ELSE
 
-    ! --------------------------------------------------------------------
-    ! P1> Thermalization of precipitation falling from the overlying layer
-    ! --------------------------------------------------------------------
-    ! Computes air temperature variation due to enthalpy transported by
-    ! precipitation. Precipitation is then thermalized with the air in the
-    ! layer. 
-    ! The precipitation should remain thermalized throughout the different
-    ! thermodynamical transformations. 
-    ! The corresponding water mass should
-    ! be added when calculating the layer's enthalpy change with 
-    ! temperature
-    ! See lmdzpedia page todoan
-    ! todoan: check consistency with ice phase
-    ! todoan: understand why several steps
-    ! ---------------------------------------------------------------------
-    
-    IF (iftop) THEN
-
-        DO i = 1, klon
-            zmqc(i) = 0.
-        ENDDO
-
-    ELSE
-
-        DO i = 1, klon
- 
-            zmair=(paprs(i,k)-paprs(i,k+1))/RG
-            ! no condensed water so cp=cp(vapor+dry air)
-            ! RVTMP2=rcpv/rcpd-1
-            zcpair=RCPD*(1.0+RVTMP2*zq(i)) 
-            zcpeau=RCPD*RVTMP2
-
-            ! zmqc: precipitation mass that has to be thermalized with 
-            ! layer's air so that precipitation at the ground has the
-            ! same temperature as the lowermost layer
-            zmqc(i) = (zrfl(i)+zifl(i))*dtime/zmair
-            ! t(i,k+1)+d_t(i,k+1): new temperature of the overlying layer
-            zt(i) = ( ztupnew(i)*zmqc(i)*zcpeau + zcpair*zt(i) ) &
-             / (zcpair + zmqc(i)*zcpeau)
-
-        ENDDO
- 
-    ENDIF
-
-    qice_ini = qi_seri(:,k)
-    ! --------------------------------------------------------------------
-    ! P2> Precipitation evaporation/sublimation/melting
-    ! --------------------------------------------------------------------
-    ! A part of the precipitation coming from above is evaporated/sublimated/melted.
-    ! --------------------------------------------------------------------
-    
-    IF (iflag_evap_prec.GE.1) THEN 
-
-        ! Calculation of saturation specific humidity
-        ! depending on temperature:
-        CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,0,.false.,zqs,zdqs)
-        ! wrt liquid water
-        CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,1,.false.,qsl,dqsl)
-        ! wrt ice
-        CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,2,.false.,qsi,dqsi)
-
-        DO i = 1, klon
-
-            ! if precipitation
-            IF (zrfl(i)+zifl(i).GT.0.) THEN
-
-            ! LudoTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec>=4).
-            ! c_iso: likely important to distinguish cs from neb isotope precipitation
-
-                IF (iflag_evap_prec.GE.4) THEN
-                    zrfl(i) = zrflclr(i)
-                    zifl(i) = ziflclr(i)
-                ENDIF
-
-                IF (iflag_evap_prec.EQ.1) THEN
-                    znebprecip(i)=zneb(i)
-                ELSE
-                    znebprecip(i)=MAX(zneb(i),znebprecip(i))
-                ENDIF
-
-                IF (iflag_evap_prec.GT.4) THEN
-                ! Max evaporation not to saturate the clear sky precip fraction
-                ! i.e. the fraction where evaporation occurs
-                    zqev0 = MAX(0.0, (zqs(i)-zq(i))*znebprecipclr(i))
-                ELSEIF (iflag_evap_prec .EQ. 4) THEN
-                ! Max evaporation not to saturate the whole mesh
-                ! Pay attention -> lead to unrealistic and excessive evaporation
-                    zqev0 = MAX(0.0, zqs(i)-zq(i))
-                ELSE
-                ! Max evap not to saturate the fraction below the cloud
-                    zqev0 = MAX(0.0, (zqs(i)-zq(i))*znebprecip(i))
-                ENDIF
-
-                ! Evaporation of liquid precipitation coming from above
-                ! dP/dz=beta*(1-q/qsat)*sqrt(P)
-                ! formula from Sundquist 1988, Klemp & Wilhemson 1978
-                ! LTP: evaporation only in the clear sky part (iflag_evap_prec>=4)
-
-                IF (iflag_evap_prec.EQ.3) THEN
-                    zqevt = znebprecip(i)*coef_eva*(1.0-zq(i)/qsl(i)) &
-                    *SQRT(zrfl(i)/max(1.e-4,znebprecip(i)))        &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ELSE IF (iflag_evap_prec.GE.4) THEN
-                     zqevt = znebprecipclr(i)*coef_eva*(1.0-zq(i)/qsl(i)) &
-                    *SQRT(zrfl(i)/max(1.e-8,znebprecipclr(i))) &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ELSE
-                    zqevt = 1.*coef_eva*(1.0-zq(i)/qsl(i))*SQRT(zrfl(i)) &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ENDIF
-
-                zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
-                    *RG*dtime/(paprs(i,k)-paprs(i,k+1)) 
-
-                ! sublimation of the solid precipitation coming from above
-                IF (iflag_evap_prec.EQ.3) THEN
-                    zqevti = znebprecip(i)*coef_sub*(1.0-zq(i)/qsi(i)) &
-                    *SQRT(zifl(i)/max(1.e-4,znebprecip(i))) &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ELSE IF (iflag_evap_prec.GE.4) THEN
-                     zqevti = znebprecipclr(i)*coef_sub*(1.0-zq(i)/qsi(i)) &
-                    *SQRT(zifl(i)/max(1.e-8,znebprecipclr(i))) &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ELSE
-                    zqevti = 1.*coef_sub*(1.0-zq(i)/qsi(i))*SQRT(zifl(i)) &
-                    *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-                ENDIF
-
-                zqevti = MAX(0.0,MIN(zqevti,zifl(i))) &
-                *RG*dtime/(paprs(i,k)-paprs(i,k+1))
-
-                ! A. JAM
-                ! Evaporation limit: we ensure that the layer's fraction below
-                ! the cloud or the whole mesh (depending on iflag_evap_prec)
-                ! does not reach saturation. In this case, we 
-                ! redistribute zqev0 conserving the ratio liquid/ice 
-
-                IF (zqevt+zqevti.GT.zqev0) THEN
-                    zqev=zqev0*zqevt/(zqevt+zqevti)
-                    zqevi=zqev0*zqevti/(zqevt+zqevti)
-                ELSE
-                    zqev=zqevt
-                    zqevi=zqevti
-                ENDIF
-
-                !--Diagnostics
-                dqreva(i,k) = - zqev / dtime
-                dqssub(i,k) = - zqevti / dtime
-
-                ! New solid and liquid precipitation fluxes after evap and sublimation
-                zrfln(i) = Max(0.,zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1))  &
-                         /RG/dtime)
-                zifln(i) = Max(0.,zifl(i) - zqevi*(paprs(i,k)-paprs(i,k+1)) &
-                         /RG/dtime)
-                
-
-                ! vapor, temperature, precip fluxes update
-                ! vapor is updated after evaporation/sublimation (it is increased)
-                zq(i) = zq(i) - (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
-                * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
-                ! zmqc is the total condensed water in the precip flux (it is decreased)
-                zmqc(i) = zmqc(i) + (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
-                * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
-                ! air and precip temperature (i.e., gridbox temperature)
-                ! is updated due to latent heat cooling
-                zt(i) = zt(i) + (zrfln(i)-zrfl(i))        &
-                * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime    &
-                * RLVTT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i))) &
-                + (zifln(i)-zifl(i))                      &
-                * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime    &
-                * RLSTT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))
-
-                ! New values of liquid and solid precipitation 
-                zrfl(i) = zrfln(i)
-                zifl(i) = zifln(i)
-
-                ! c_iso here call_reevap that updates isotopic zrfl, zifl (in inout)
-                !                         due to evap + sublim                                     
-                                           
-
-                IF (iflag_evap_prec.GE.4) THEN
-                    zrflclr(i) = zrfl(i)
-                    ziflclr(i) = zifl(i)
-                    IF(zrflclr(i) + ziflclr(i).LE.0) THEN
-                        znebprecipclr(i) = 0.0
-                    ENDIF
-                    zrfl(i) = zrflclr(i) + zrflcld(i)
-                    zifl(i) = ziflclr(i) + ziflcld(i)
-                ENDIF
-
-                ! c_iso duplicate for isotopes or loop on isotopes
-
-                ! Melting:
-                zmelt = ((zt(i)-RTT)/(ztfondue-RTT)) ! JYG
-                ! precip fraction that is melted
-                zmelt = MIN(MAX(zmelt,0.),1.)
-
-                ! update of rainfall and snowfall due to melting
-                IF (iflag_evap_prec.GE.4) THEN
-                    zrflclr(i)=zrflclr(i)+zmelt*ziflclr(i)
-                    zrflcld(i)=zrflcld(i)+zmelt*ziflcld(i)
-                    zrfl(i)=zrflclr(i)+zrflcld(i)
-                ELSE
-                    zrfl(i)=zrfl(i)+zmelt*zifl(i)
-                ENDIF
-
-
-                ! c_iso: melting of isotopic precipi with zmelt (no fractionation)
-
-                ! Latent heat of melting because of precipitation melting
-                ! NB: the air + precip temperature is simultaneously updated
-                zt(i)=zt(i)-zifl(i)*zmelt*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
-                *RLMLT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))
-               
-                IF (iflag_evap_prec.GE.4) THEN
-                    ziflclr(i)=ziflclr(i)*(1.-zmelt)
-                    ziflcld(i)=ziflcld(i)*(1.-zmelt)
-                    zifl(i)=ziflclr(i)+ziflcld(i)
-                ELSE
-                    zifl(i)=zifl(i)*(1.-zmelt)
-                ENDIF
-
-            ELSE
-                ! if no precip, we reinitialize the cloud fraction used for the precip to 0 
-                znebprecip(i)=0.
-
-            ENDIF ! (zrfl(i)+zifl(i).GT.0.)
-
-        ENDDO ! loop on klon
-
-    ENDIF ! (iflag_evap_prec>=1)
+      CALL histprecip_precld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
+                        zt, ztupnew, zq, zmqc, zneb, znebprecipclr, &
+                        zrfl, zrflclr, zrflcld, &
+                        zifl, ziflclr, ziflcld, &
+                        dqreva(:,k), dqssub(:,k) &
+                        )
 
     ENDIF ! (ok_poprecip)
-
-    ! --------------------------------------------------------------------
-    ! End precip evaporation
-    ! --------------------------------------------------------------------
     
     ! Calculation of qsat, L/Cp*dqsat/dT and ncoreczq counter
@@ -782,5 +554,5 @@
     
     ! --------------------------------------------------------------------
-    ! P3> Cloud formation
+    ! P2> Cloud formation
     !---------------------------------------------------------------------
     !
@@ -793,5 +565,5 @@
     ! -------------------------------------------------------------------
 
-        ! P3.1> With the PDFs (log-normal, bigaussian) 
+        ! P2.1> With the PDFs (log-normal, bigaussian) 
         ! cloud properties calculation with the initial values of t and q
         ! ----------------------------------------------------------------
@@ -1038,5 +810,5 @@
         ENDDO         ! iter=1,iflag_fisrtilp_qsat+1
 
-        ! P3.2> Final quantities calculation 
+        ! P2.2> Final quantities calculation 
         ! Calculated variables: 
         !   rneb : cloud fraction
@@ -1136,8 +908,10 @@
 
     ! ----------------------------------------------------------------
-    ! P4> Precipitation formation 
+    ! P3> Precipitation processes, after cloud formation 
+    !     - precipitation formation, melting/freezing
     ! ----------------------------------------------------------------
 
     !================================================================
+    ! Flag for the new and more microphysical treatment of precipitation from Atelier Nuage (R)
     IF (ok_poprecip) THEN
 
@@ -1468,10 +1242,10 @@
     ENDIF ! ok_poprecip
 
-    ! End of precipitation formation
-    ! --------------------------------
+    ! End of precipitation processes after cloud formation
+    ! ----------------------------------------------------
 
 
     !----------------------------------------------------------------------
-    ! P5> Calculation of cloud condensates amount seen by radiative scheme
+    ! P4> Calculation of cloud condensates amount seen by radiative scheme
     !----------------------------------------------------------------------
 
@@ -1506,5 +1280,5 @@
 
     ! ----------------------------------------------------------------
-    ! P6> Wet scavenging
+    ! P5> Wet scavenging
     ! ----------------------------------------------------------------
 
@@ -1563,5 +1337,5 @@
     
     !------------------------------------------------------------
-    ! P7 > write diagnostics and outputs
+    ! P6 > write diagnostics and outputs
     !------------------------------------------------------------
    
